
/* Compatible models:
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "LG_RS232";

/* 
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 1
}

Screen.prototype.maxAttempts = {
    power : 3,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/    
//Conf
Screen.prototype.portValues = {
        name : '',
        config : {
                baudRate : 9600,
                dataBits : 8,
                stopBits : 1
        },
        parser : {
            type : 'byteDelimiter' ,
            delimiter : [120]
        }   
}


//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    return ( "00" + id.toString(16)).substr(-2) 
};
Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var command = 'ka ' + this.data.formated_remote_id + ' ff\r'
    return command;
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('ascii');

    if (data.includes('OK01') ){
        this.status.power = 1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else if (data.includes('OK00') ){
        this.status.power = 0;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.power = -1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};

Screen.prototype.endPowerQuerry = function (){
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var command = 'xb ' + this.data.formated_remote_id + ' ff\r'
    return command;
};


Screen.prototype.translateChannelQuerry = function ( data ){
    this.status.lastCMD = data.toString('ascii');

    if (data.includes('OK60x' )){
        this.status.channel = 'PC';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK90x')){
        this.status.channel = 'HDMI1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK91x')){
        this.status.channel = 'HDMI2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK20x')){
        this.status.channel = 'AV1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK21x')){
        this.status.channel = 'AV2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK40x')){
        this.status.channel = 'COMPONENT1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK41x')){
        this.status.channel = 'COMPONENT2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK00x')){
        this.status.channel = 'DTV Antenna';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK01x')){
        this.status.channel = 'DTV Cable';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK10x')){
        this.status.channel = 'Analog Antenna';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes('OK11x')){
        this.status.channel = 'Analog Cable';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.channel = 'Unknown';
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};

Screen.prototype.endChannelQuerry = function (){};
    
/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
        this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
        return;
    };

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var command = 'ka ' + this.data.formated_remote_id + ' 01\r'
    return command;
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };


Screen.prototype.generateOffQuerry  = function (){
    var command = 'ka ' + this.data.formated_remote_id + ' 00\r'
    return command;
};
Screen.prototype.translateOffQuerry = function ( data ){ return; };


/******************************** FREE COMMAND: REBOOT PROTOTYPING ********************************/
Screen.prototype.singularRebootAvailable = true;
//Screen.prototype.allRebootAvailable = true;


/******************************** FREE COMMAND: CUSTOM PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( command ){
    return ( command + '\r' );
};
Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };


